#include <iostream>
#include <cstdio>
#include <vector>
using namespace std;

//  Emulation one step of mutation process
vector<int> mutation(vector<int>& genom) {
    vector<int> newGenom;
    newGenom.resize(genom.size());
    for (int i = 0; i < genom.size(); i++) {
        if (genom[i] != 0) {
            newGenom[genom[i] - 1]++;//  Using zero-numeration to have all vector cells used.
                                     //  This line is language/implementation-specific, so there are plenty of ways of doing it right.
        }
    }
    return newGenom;
}

int main() {
    freopen("mutation.dat", "r", stdin);
    freopen("mutation.sol", "w", stdout);
    int n, k;
    scanf("%d%d", &n, &k);
    vector<int> genom;
    for (int i = 0; i < n; i++) {  //  Reading an input.
        int x;
        scanf("%d", &x);
        genom.push_back(x);
    }
    while (k--) {
        genom = mutation(genom);
        int sum = 0;
        for (int i = 0; i < genom.size() && sum <= 1; i++) {
            sum += genom[i];
        }
        //  Checking whether we have just reached a cycle which is of form [1, 0, 0, ..., 0] or [0, 0, 0, ..., 0]
        if ((sum == 1 && genom[0] == 1) || sum == 0) {
            break;
        }
    }
    for (int i = 0; i + 1 < genom.size(); i++) { //  Printing the result.
        printf("%d ", genom[i]);
    }
    printf("%d\n", genom.back());
    return 0;
}