#include <iostream>
#include <string>
#include <memory.h>
#include <cstdio>
#include <algorithm>
#include <cmath>
#include <map>
#include <set>
#include <vector>
#include <fstream>
#include <queue>
#include <list>

using namespace std;
#define pb push_back
#define mp make_pair
#define FOR(i,a,b) for(int i=a;i<b;++i)

int n, m;
int a[200005];
int b[200005];
int tree[2000005];
int w[2000005];


void build(int v, int l, int r) {
    w[v] = 0;
    if (l == r) {
        tree[v] = a[l];
        return;
    }
    int m = (l + r) / 2;
    build(v + v, l, m); build(v + v + 1, m + 1, r);
    tree[v] = a[r];
}

void push(int v) {
    tree[v + v] -= w[v];
    tree[v + v + 1] -= w[v];
    w[v + v] += w[v];
    w[v + v + 1] += w[v];
    w[v] = 0;
}

int get(int v, int l, int r, int pos) {
    if (w[v] > 0) {
        if (l != r) push(v);
        w[v] = 0;
    }
    if (l == r) return tree[v];
    int m = (l + r) / 2;
    if (m >= pos) return get(v + v, l, m, pos); else return get(v + v + 1, m + 1, r, pos);
}

int getInterval(int v, int l, int r, int val) {
    if (w[v] > 0) {
        if (l != r) {
            push(v);
        }
        w[v] = 0;
    }

    if (l == r) return l;
    int m = (l + r) / 2;
    if (tree[v + v] <= val) return getInterval(v + v, l, m, val);
    else return getInterval(v + v + 1, m + 1, r, val);
}

void update(int v, int l, int r, int ll, int rr) {
    if (w[v] > 0) {
        if (l != r) push(v);
        w[v] = 0;
    }
    if (max(ll, l) > min(r, rr)) return;
    if (ll <= l && r <= rr) {
        w[v]++;
        tree[v]--;
        return;
    }
    int m = (l + r) / 2;
    update(v + v, l, m, ll, rr);
    update(v + v + 1, m + 1, r, ll, rr);
    tree[v] = min(tree[v + v], tree[v + v + 1]);
}

void write(int v, int l, int r) {
    if (w[v] > 0) {
        if (l != r) push(v);
        w[v] = 0;
    }
    if (l == r) {
        cout << tree[v] << " ";
        return;
    }
    int m = (l + r) / 2;
    write(v + v, l, m);
    write(v + v + 1, m + 1, r);
}

void solve() {
    scanf("%d%d", &n, &m);
    long long sa = 0;
    for (int i = 0; i < n; ++i) {
        scanf("%d", &a[i]);
        sa += a[i];
    }
    for (int i = 0; i < m; ++i) {
        scanf("%d", &b[i]);
        sa -= b[i];
    }
    if (m > n) {
        for (int i = 0; i < m; ++i) {
            swap(a[i], b[i]);
        }
        swap(n, m);
    }

    if (sa != 0) {
        puts("0");
        return;
    }
    sort(a, a + n);
    reverse(a, a + n);
    build(1, 0, n - 1);
    for (int i = 0; i < m; ++i) {
        if (b[i] == 0) continue;
        int val = get(1, 0, n - 1, b[i] - 1);
        if (val == 0) {
            puts("0");
            return;
        }
        int l = getInterval(1, 0, n - 1, val);
        int r = getInterval(1, 0, n - 1, val - 1);
        int E = get(1, 0, n - 1, r);
        if (E != val) r--;

        if (l != 0) update(1, 0, n - 1, 0, l - 1);
        int all = b[i] - l;
        if (all > 0) {
            update(1, 0, n - 1, r - all + 1, r);
        }
    }
    puts("1");
}
int main() {
    freopen("puzzle.dat","r",stdin);
    freopen("puzzle.sol","w",stdout);
   // freopen("input.txt","r",stdin);
    int T;
    scanf("%d", &T);
    while (T--) {
        solve();
    }
    return 0;
}
