#include <iostream>
#include <string>
#include <memory.h>
#include <cstdio>
#include <algorithm>
#include <cmath>
#include <map>
#include <set>
#include <vector>
#include <fstream>
#include <queue>
#include <list>

using namespace std;
#define pb push_back
#define mp make_pair
#define FOR(i,a,b) for(int i=a;i<b;++i)
const int inf = 1000000001;
int SIZE = 0;
int xx[4000005];
long double minval[4000005], maxval[4000005];
struct Seg{
    int x, l, r;
    Seg(int _x, int _l, int _r) {
        x = _x; l = _l; r = _r;
    }
    Seg() {}
};
const int MAXN = 3000005;
Seg all[MAXN];
int n, sz;
int x[MAXN], y[MAXN];

void add_segment(int x, int l, int r){
    Seg val = Seg(x, l, r);
    all[sz++] = val;
}

struct circle {
    int x, y, r;
    circle() {}
    void read() {
        scanf("%d%d%d", &x, &y, &r);
    }

    int get(long long val) {
        int ret = sqrt(1.0 * val);
        for (int Q = ret + 2; Q >= ret; --Q) {
            if (1LL * Q * Q <= val) return Q;
        }
        return ret - 1;
    }

    void add_segments() {
        for (int cx = 0; cx <= r; ++cx) {
            int d = get(1LL * r * r - 1LL * cx * cx);
            add_segment(x + cx, y - d, y + d);
            if (cx != 0) add_segment(x - cx, y - d, y + d);
        }
    }
};
int ww = 0;
circle c[200000];
bool cmp(Seg a, Seg b) {
    return (a.x < b.x);
}

long double intersect(int x1, int y1, int x2, int y2, int x) {
    if (x1 > x2 || (x1 == x2 && y1 > y2)) {
        swap(x1, x2); swap(y1, y2);
    }

    if (x < x1 || x > x2) return inf;
    if (x1 == x2) return y1;
    if (y1 == y2) return y1;
    int vx = x2 - x1;
    int vy = y2 - y1;

    long double D = 1.0 * (x - x1) / (x2 - x1);
    return y1 + (y2 - y1) * D;
}

pair < int, int > get(int cx) {
    long double mn = minval[ww];
    long double mx = maxval[ww];
/*
    for (int i = 0; i < n; ++i) {
        double val = intersect(x[i], y[i], x[i + 1], y[i + 1], cx);
        if (val == inf) continue;
        mn = min(mn, val); mx = max(mx, val);
    }
*/
    mx += 1e-9;
    int l = (int)mn, r = floor(mx);
    if (mn > l) l++;
    return make_pair(l, r);
}
int ss;
pair < int, int > q[4000005];
long long solve(pair < int, int > Q) {
    int l, r;
    l = Q.first, r = Q.second;
    sort(q, q + ss);
    long long ret = 0;
    for (int i = 0; i < ss; ++i) {
        if (l > r) break;
        if (q[i].first > r) break;
        if (max(l, q[i].first) > min(r, q[i].second)) continue;

        int lc = max(l, q[i].first), rc = min(q[i].second, r);
        ret += rc - lc + 1;
        l = rc + 1;
    }
    return ret;
}
bool onLine(int x1, int y1, int x2, int y2, int x3, int y3) {
    long long A = y2 - y1;
    long long B = x1 - x2;
    long long C = - A * x1 - B * y1;
    return (A * x3 + B * y3 + C) == 0;
}

void getPoints(int x1, int y1, int x2, int y2) {
    if (x1 > x2 || (x1 == x2 && y1 > y2)) {
        swap(x1, x2); swap(y1, y2);
    }

    if (xx[0] > x2) return;
    if (xx[SIZE - 1] < x1) return;

    int leftSide = SIZE;
    int rightSide = -1;

    int l = -1;
    int r = SIZE - 1;
    while (l + 1 < r) {
        int c = (l + r) / 2;
        if (xx[c] < x1) l = c; else r = c;
    }

    leftSide = r;

    l = 0; r = SIZE;
    while (l + 1 < r) {
        int c = (l + r) / 2;
        if (xx[c] <= x2) l = c; else r = c;
    }
    rightSide = l;

    for (int i = leftSide; i < rightSide + 1; ++i) {
   //     if (x1 > xx[i] || x2 < xx[i]) continue;
        long double val = intersect(x1, y1, x2, y2, xx[i]);
        if (val == inf) {
            cout << "SOMETHING GOES WRONG" << endl;
            return;
        }
        minval[i] = min(minval[i], val);
        maxval[i] = max(maxval[i], val);
    }
}

int main() {
freopen("trees.dat","r",stdin);
freopen("trees.sol","w",stdout);    
scanf("%d", &n);
    for (int i = 0; i < n; ++i) {
        scanf("%d%d", &x[i], &y[i]);
    }

    int N = 1;
    x[n] = x[0], y[n] = y[0];
    for (int i = 1; i < n; ++i) {
        if (!onLine(x[N - 1], y[N - 1], x[i], y[i], x[i + 1], y[i + 1])) {
            x[N] = x[i];
            y[N++] = y[i];
        }
    }
    n = N;
    int m; scanf("%d", &m);
    for (int i = 0; i < m; ++i) {
        c[i].read();
    }
    for (int i = 0; i < m; ++i) {
        c[i].add_segments();
    }

    sort(all, all + sz, cmp);
    for (int i = 0; i < sz; ++i) {
        minval[i] = inf;
        maxval[i] = -inf;
    }
    xx[SIZE++] = all[0].x;
    for (int i = 1; i < sz; ++i) {
        if (xx[SIZE - 1] != all[i].x) {
            xx[SIZE++] = all[i].x;
        }
    }

    for (int i = 0; i < n; ++i) {
        getPoints(x[i], y[i], x[i + 1], y[i + 1]);
    }
    int i = 0;
    long long ans = 0;
    while (i < sz) {
        int cur = i;
        while (cur < sz && all[cur].x == all[i].x) cur++;
        pair < int, int > S = get(all[i].x);
        int lc = i, rc = cur;
        i = cur;
        ww++;
        if (S.first > S.second) continue;
        ss = 0;
        for (int j = lc; j < rc; ++j) {
            q[ss++] = make_pair(all[j].l, all[j].r);
        }
        ans += solve(S);
    }
    cout << ans << endl;
    return 0;
}

