#include <iostream>
#include <string>
#include <memory.h>
#include <cstdio>
#include <algorithm>
#include <cmath>
#include <map>
#include <set>
#include <vector>
#include <fstream>
#include <queue>
#include <list>

using namespace std;
#define pb push_back
#define mp make_pair
#define FOR(i,a,b) for(int i=a;i<b;++i)
const int inf = 1000000001;
struct Seg{
    int x, l, r;
    Seg(int _x, int _l, int _r) {
        x = _x; l = _l; r = _r;
    }
    Seg() {}
};
const int MAXN = 3000005;
Seg all[MAXN];
int n, sz;
int x[MAXN], y[MAXN];

void add_segment(int x, int l, int r){
    Seg val = Seg(x, l, r);
    all[sz++] = val;
}

struct circle {
    int x, y, r;
    circle() {}
    void read() {
        scanf("%d%d%d", &x, &y, &r);
    }

    int get(long long val) {
        int ret = sqrt(1.0 * val);
        for (int Q = ret + 2; Q >= ret; --Q) {
            if (1LL * Q * Q <= val) return Q;
        }
        return ret - 1;
    }

    void add_segments() {
        for (int cx = 0; cx <= r; ++cx) {
            int d = get(1LL * r * r - 1LL * cx * cx);
            add_segment(x + cx, y - d, y + d);
            if (cx != 0) add_segment(x - cx, y - d, y + d);
        }
    }
};

circle c[200000];
bool cmp(Seg a, Seg b) {
    return (a.x < b.x);
}

double intersect(int x1, int y1, int x2, int y2, int x) {
    if (x1 > x2 || (x1 == x2 && y1 > y2)) {
        swap(x1, x2); swap(y1, y2);
    }

    if (x < x1 || x > x2) return inf;
    if (x1 == x2) return y1;
    double dist = sqrt(1.0 * (x1 - x2) * (x1 - x2) + 1.0 * (y1 - y2) * (y1 - y2));
    double vx = x2 - x1; vx /= dist;
    double vy = y2 - y1; vy /= dist;

    double D = (x - x1) / vx;
    return y1 + vy * D;
}

pair < int, int > get(int cx) {
    double mn = inf;
    double mx = -mn;

    for (int i = 0; i < n; ++i) {
        double val = intersect(x[i], y[i], x[i + 1], y[i + 1], cx);
        if (val == inf) continue;
        mn = min(mn, val); mx = max(mx, val);
    }
    mx += 1e-9;
    int l = (int)mn, r = floor(mx);
    if (mn > l) l++;
    return make_pair(l, r);
}
int ss;
pair < int, int > q[4000005];
long long solve(pair < int, int > Q) {
    int l, r;
    l = Q.first, r = Q.second;
    sort(q, q + ss);
    long long ret = 0;
    for (int i = 0; i < ss; ++i) {
        if (l > r) break;
        if (q[i].first > r) break;
        if (max(l, q[i].first) > min(r, q[i].second)) continue;

        int lc = max(l, q[i].first), rc = min(q[i].second, r);
        ret += rc - lc + 1;
        l = rc + 1;
    }
    return ret;
}

int main() {
 freopen("trees.dat", "r", stdin);
    freopen("trees.sol", "w", stdout);
   
    //freopen("input.txt","r",stdin);
    scanf("%d", &n);
    for (int i = 0; i < n; ++i) {
        scanf("%d%d", &x[i], &y[i]);
    }
    int m; scanf("%d", &m);
    for (int i = 0; i < m; ++i) {
        c[i].read();
    }

    for (int i = 0; i < m; ++i) {
        c[i].add_segments();
    }

    sort(all, all + sz, cmp);
    x[n] = x[0]; y[n] = y[0];
    int i = 0;
    long long ans = 0;
    while (i < sz) {
        int cur = i;
        while (cur < sz && all[cur].x == all[i].x) cur++;
      //  cout << "I: " << i << " " << all[i].x << endl;
        pair < int, int > S = get(all[i].x);
        int lc = i, rc = cur;
        i = cur;
        if (S.first > S.second) continue;
    //    cout << "* " << endl;
   //     cout << S.first << " " << S.second << endl;
        ss = 0;
        for (int j = lc; j < rc; ++j) {
            q[ss++] = make_pair(all[j].l, all[j].r);
        }
        ans += solve(S);
    }
    cout << ans << endl;
    return 0;
}

